<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>District</title>
</head>
<body>
    <div class="container">
        <div class="d-flex justify-content-center mt-5">
        <div class="card card-danger w-50">
            <div class="card-header">
                <h3 class="card-title">Quận, huyện</h3>
            </div>
            <div class="card-body">
                <div class="row form-group">
                    <label for="" class="col-sm-3">Tên</label>
                    <div class="col-sm-9">
                        <input id="inp-district" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <label for="" class="col-sm-3">Quận-Huyện</label>
                    <div class="col-sm-9">
                        <select name="prefix" id="select-prefix" class="form-control">
                            <option value="none">Quận-Huyện</option>
                            <option value="1">Quận</option>
                            <option value="2">Huyện</option>
                            <option value="3">Thị xã</option>
                            <option value="4">Thành phố</option>

                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <label for="" class="col-sm-3">Tên TP</label>
                    <div class="col-sm-9">
                        <select name="province" id="select-province" class="form-control">
                            <option value="none">Tên</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-6">
                        <button id="btn-add" class="btn btn-primary">Add</button>
                        <button id="btn-update" class="btn btn-primary" style="display: none;">Update</button>
                        <button id="btn-delete" class="btn btn-danger" style="display: none;">Delete</button>
                        <button id="btn-cancel" class="btn btn-secondary">Cancel</button>
                        
                    </div>
                </div>
                
            </div>
        </div>

    </div>
    <table id="table-district" class="table table-stripped table-bordered table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>Quận, Huyện</th>
                <th>Tên</th>
            </tr>
        </thead>
        <tbody>

        </tbody>
    </table>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableDistrict = $("#table-district").DataTable({
        columns: [
            { data: "id"},
            { data: "prefix"},
            { data: "name"},

        ],
        columnDefs: [
            {
                target: 3,
                render: function() {

                }

            }
        ]
    })

    var gDistrictId = null;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Thực thi sự kiện tải trang
    onPageLoading();
    
    // Thực thi sự kiến nhấn vào row
    $("#table-district").on("click", "tr", function() {
        onClickOnDistrictRow(this);
    });

    // Thực thi sự kiện add district mới
    $("#btn-add").on("click", function() {
        onBtnAddNewDistrictClick();
    });

    // Thực thi sự kiện nhấn nút update district
    $("#btn-update").on("click", function() {
        onBtnUpdateDistrictClick();
    })

    // Thực thi sự kiện nhất nút delete district
    $("#btn-delete").on("click", function() {
        onBtnDeleteDistrictClick();
    })

    // Thực thi sự kiện chọn district
    $("#select-province").on("change", function() {
        callApiToLoadListDistrictByProvinceId()
    })


    // Thực thi sự kiện nhấn nút cancel
    $("#btn-cancel").on("click", function() {
        onBtnCancelClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện tải trang
    function onPageLoading() {
        callApiToLoadListDistrict();
        callApiToLoadListProvince();
    }
    

    // Hàm sự kiện nhấn nút add district
    function onBtnAddNewDistrictClick() {
        var vNewDistrict = {
            name: "",
            prefix: ""
        }
        getDataDistrictForm(vNewDistrict);
        var vValidate = validateDistrict(vNewDistrict);
        if(vValidate) {
            callApiToCreateNewDistrict(vNewDistrict);
        }

    }

    // Hàm sự kiện nhấn nút update district
    function onBtnUpdateDistrictClick() {
        var vUpdateDistrict = {
            name: "",
            prefix: ""
        }
        getDataDistrictForm(vUpdateDistrict);
        var vValidate = validateDistrict(vUpdateDistrict);
        if(vValidate) {
            callApiToUpdateDistrict(vUpdateDistrict);
        }
    }

    // Hàm sự kiện nhất nút delete district
    function onBtnDeleteDistrictClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/district/" + gDistrictId,
            success: function(paramRes) {
                alert("Xóa thành công!");
                callApiToLoadListDistrictByProvinceId();
                resetFormDistrict();
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Xóa thất bại, vui lòng thử lại!")
            }
        })
    }


    // Hàm xử lý sự kiện nhấn nút cancel
    function onBtnCancelClick() {
        resetFormDistrict();
        callApiToLoadListDistrict();
    }
    // Hàm xử lý sự kiện click vào row trong table
    function onClickOnDistrictRow(paramRow) {
        var vDataRow = gTableDistrict.row(paramRow).data();
        gDistrictId = vDataRow.id;
        $("#inp-district").val(vDataRow.name);
        console.log(vDataRow.prefix)
        if(vDataRow.prefix == "Quận") {
            $("#select-prefix").val(1);
        }
        if(vDataRow.prefix == "Huyện") {
            $("#select-prefix").val(2);
        }
        
        if(vDataRow.prefix == "Thị xã") {
            $("#select-prefix").val(3);
        }

        if(vDataRow.prefix == "Thành phố") {
            $("#select-prefix").val(4);
        }
        $("#btn-add").hide();
        $("#btn-update").show();
        $("#btn-delete").show();

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi api load ra danh sách district
    function callApiToLoadListDistrict() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/districts",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToTable(paramRes);
            },
            error: function(paramError){
                console.log(paramError.status);
            }
         })
    }


    // Hàm gọi api dể load danh sách province vào thẻ select district
    // Hàm gọi api load ra danh sách district
    function callApiToLoadListProvince() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/provinces",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToSelectProvince(paramRes);
            },
            error: function(paramError){
                console.log(paramError.status);
            }
         })
    }

    // Load dữ liệu district vào table
    function loadDataToTable(paramDistrictData) {
        gTableDistrict.clear();
        gTableDistrict.rows.add(paramDistrictData);
        gTableDistrict.draw();
    }

    // Hàm thu thập dữ liệu từ form
    function getDataDistrictForm(paramDistrictData) {
        paramDistrictData.name = $("#inp-district").val();
        paramDistrictData.prefix = $("#select-prefix option:selected").text();
    }

    // Hàm validate dữ liệu district
    function validateDistrict(paramDistrictData) {
        if(paramDistrictData.name == "") {
            alert("Vui lòng nhập tên huyện!");
            return false;
        }
        if(paramDistrictData.prefix == "") {
            alert("Vui lòng chọn prefix")
            return false;
        }
        return true;
    }

    // Gọi API để tạo mới 1 district
    function callApiToCreateNewDistrict(paramDistrictData) {
        console.log(paramDistrictData);
        var vProvinceValue = $("#select-province").val();
        $.ajax({
            type: "POST",
            url: "http://localhost:8080/province/" + vProvinceValue + "/districts",
            contentType: "application/json",
            data: JSON.stringify(paramDistrictData),
            success: function(paramRes) {
                alert("Tạo mới thành công!");
                callApiToLoadListDistrictByProvinceId(vProvinceValue);
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Tạo mới thất bại, vui lòng thử lại!");
            }
        })
    }

    // Hàm gọi API để cập nhật District
    function callApiToUpdateDistrict(paramDistrictData) {
        $.ajax({
            type: "PUT",
            url: "http://localhost:8080/district/" + gDistrictId,
            contentType: "application/json",
            data: JSON.stringify(paramDistrictData),
            success: function(paramRes) {
                alert("Cập nhật thành công!");
                callApiToLoadListDistrictByProvinceId();
                resetFormDistrict();
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Cập nhật thất bại, vui lòng thử lại!");
            }
        })
    }

    // Hàm reset form
    function resetFormDistrict() {
        $("#inp-district").val("");
        $("#select-prefix").val("none");
        $("#btn-add").show();
        $("#btn-update").hide();
        $("#btn-delete").hide();
        $("#select-province").val("none");
        
    }

    // Hàm load data vào thẻ select province
    function loadDataToSelectProvince(paramProvinceData) {
        var vSelectProvince = $("#select-province");
        for(var i = 0; i < paramProvinceData.length; i++) {
            $("<option>", {
                value: paramProvinceData[i].id,
                text: paramProvinceData[i].name
            }).appendTo(vSelectProvince);
        }
    }


    // Hàm call API để load danh sách district
    function callApiToLoadListDistrictByProvinceId(){
        var vProvinceId = $("#select-province").val();
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/province/" + vProvinceId + "/districts",
            success: function(paramRes) {
                loadDataToTable(paramRes);
            },
            error: function(paramError) {
                console.log(paramError.status);
            }
        })
    }
</script>
</html>